// MulSelDemo.cpp : Ӧóڵ㡣
//

#include "stdafx.h"
#include "MulSelDemo.h"
#include "MulSelCtl.h"
#include "DlgHelper.h"
#include <commctrl.h>	//for ImageList_LoadImage(...)
#include <Commdlg.h>	//for choosecolor
#include <windowsx.h>

#pragma comment(lib, "comctl32.lib")
#pragma comment(lib, "Comdlg32.lib") //for choosecolor

#define MAX_LOADSTRING 100

// ȫֱ:
HINSTANCE hInst;								// ǰʵ
TCHAR szTitle[MAX_LOADSTRING];					// ı
TCHAR szWindowClass[MAX_LOADSTRING];			// 


// ˴ģаĺǰ:
ATOM				MyRegisterClass(HINSTANCE hInstance);
ATOM MyRegisterMulSelCtl(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);


void OnNotify_MulSel(HWND hDlg, LPNMHDR pHdr);
void OnNotify_Clock(HWND hDlg, LPNMHDR pHdr);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	hInst = hInstance;
	RegisterMulSelCtl();
	return DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_ABOUTBOX), NULL, About, 0);
}

// ڡϢ
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int ctlid, eventid;
	switch (message)
	{
	case WM_INITDIALOG:
		{
			TCHAR fname[MAX_PATH];
			GetAppFolderFileName(fname, _T("MulSel.txt"));
			HWND hCtl = GetDlgItem(hDlg, IDC_CUSTOM1);
			
			HIMAGELIST himl = ImageList_LoadImage(hInst, MAKEINTRESOURCE(IDB_IMGLIST),
				16, 4, RGB(255, 0, 255), IMAGE_BITMAP, LR_CREATEDIBSECTION);
			MulSel_SetImageList(hCtl, himl, FALSE);
			MulSel_SuspendLayout(hCtl);
			
			
			GETCHECKEDITEMS BufInfo;
			BufInfo.cSeperator = _T(',');
			BufInfo.pBufOrFilename = fname;
			MulSel_Deserialize(hCtl, &BufInfo, FALSE);
			MulSel_SetGroupsImage(hCtl, 0, 1, FALSE);

			LOGFONT lf = { 0 };
			lf.lfHeight = 16;
			lf.lfWeight = FW_NORMAL;
			_tcscpy(lf.lfFaceName, _T(""));
			HFONT hFont = CreateFontIndirect(&lf);
			MulSel_SetFont(hCtl, hFont, FALSE);

			MulSel_SetItemSize(hCtl, 56, 24, FALSE);
			MulSel_SetBkColor(hCtl, RGB(200, 240, 255), FALSE);
			MulSel_ResumeLayout(hCtl);


			CLOCKTIME ctime;
			TCHAR szText[16];
			Clock_GetTime(GetDlgItem(hDlg, IDC_CUSTOM2), &ctime);
			_stprintf(szText, _T("%02d:%02d"),
				ctime.hour, ctime.minute);
			SetDlgItemText(hDlg, IDC_EDIT_CLOCKTIME, szText);

			HWND hCombo_Unit = GetDlgItem(hDlg, IDC_CB_DRAGUNIT);
			ComboBox_AddString(hCombo_Unit, _T("1 "));
			ComboBox_AddString(hCombo_Unit, _T("5 "));
			ComboBox_SetCurSel(hCombo_Unit, 1);
		}
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		{
			ctlid = LOWORD(wParam);
			eventid = HIWORD(wParam);
			switch(ctlid)
			{
			case IDOK:
			case IDCANCEL:
				EndDialog(hDlg, ctlid);
				return (INT_PTR)TRUE;

			case IDC_ADDGROUP:
				{
					HWND hCtl = GetDlgItem(hDlg, IDC_CUSTOM1);
					MSGROUP info;
					info.fMask = MSF_TEXT | MSF_IMAGE;
					info.iImgCollaped = 0;
					info.iImgExpand = 1;
					GetDlgItemText(hDlg, IDC_GROUPTEXT, info.szText, 48);
					MulSel_AddGroup(hCtl, &info);
				}
				break;

			case IDC_ADDITEM:
				{
					HWND hCtl = GetDlgItem(hDlg, IDC_CUSTOM1);
					TCHAR szGroupText[48];

					GETITEM getitem;
					getitem.byWhich = GET_BY_TEXT;
					getitem.text = szGroupText;
					GetDlgItemText(hDlg, IDC_GROUPTEXT, szGroupText, 
						sizeof(szGroupText)/sizeof(szGroupText[0]));
					HMSGROUP hGroup = MulSel_GetGroupHandle(hCtl, &getitem);

					MSITEM info;
					info.hGroup = hGroup;
					info.fMask = MSF_TEXT | MSF_CHECKSTATE | MSF_IMAGE;
					GetDlgItemText(hDlg, IDC_ITEMTEXT, info.szText, 48);
					info.checkstate = IsDlgButtonChecked(hDlg, IDC_CHECK1);
					info.iImgChecked = 2;
					info.iImgUnchecked = 3;
					MulSel_AddItem(hCtl, &info);
				}
				break;

			case IDC_SETCOLOR:
				{
					HWND hMulSel = GetDlgItem(hDlg, IDC_CUSTOM1);
					COLORREF clrBk = MulSel_GetBkColor(hMulSel);
					COLORREF custColors[16];
					for(int i = 0; i<16; i++)
					{
						custColors[i] = RGB(255, 255, 255);
					}
					CHOOSECOLOR cc;
					cc.lStructSize = sizeof(CHOOSECOLOR);
					cc.hwndOwner = hDlg;
					cc.hInstance = NULL;
					cc.lpCustColors = custColors;
					cc.rgbResult = clrBk;
					cc.Flags = CC_RGBINIT | CC_SOLIDCOLOR;
					cc.lCustData = 0;
					cc.lpfnHook = NULL;
					cc.lpTemplateName = NULL;

					if(ChooseColor(&cc))
					{
						MulSel_SetBkColor(hMulSel, cc.rgbResult, TRUE);
					}
				}
				break;

			case IDC_CB_DRAGUNIT:
				{
					HWND hCombo_Unit = (HWND)lParam;
					int iSel = ComboBox_GetCurSel(hCombo_Unit);
					int unit[] = { 1, 5 };
					if(eventid == CBN_SELCHANGE)
					{
						Clock_SetMinuteUnit(GetDlgItem(hDlg, IDC_CUSTOM2), unit[iSel]);
					}
				}
				return TRUE;
			}
		}
		break;
	case WM_NOTIFY:
		{
			LPNMHDR pHdr = (LPNMHDR)lParam;
			switch(pHdr->idFrom)
			{
			case IDC_CUSTOM1:
				OnNotify_MulSel(hDlg, pHdr);
				break;
			case IDC_CUSTOM2:
				OnNotify_Clock(hDlg, pHdr);
				break;
			}			
		}
		break;
	}
	return (INT_PTR)FALSE;
}

void OnNotify_MulSel(HWND hDlg, LPNMHDR pHdr)
{
	switch(pHdr->code)
	{
	case MSN_CHECKITEMSCHANGE:
		{
			HWND hCtl = GetDlgItem(hDlg, IDC_CUSTOM1);
			GETCHECKEDITEMS info;
			info.pBufOrFilename = NULL;
			info.state = BST_CHECKED;
			info.bufLen = 0;
			info.itemCount = 0;
			info.cSeperator = _T(',');

			MulSel_GetCheckedItems(hCtl, &info);

			info.pBufOrFilename = new TCHAR[info.bufLen];

			if(info.pBufOrFilename != NULL)
			{
				MulSel_GetCheckedItems(hCtl, &info);
				SetDlgItemText(hDlg, IDC_CHECKEDITEMS, info.pBufOrFilename);
				delete info.pBufOrFilename;
			}						
		}
		break;
	}
}

void OnNotify_Clock(HWND hDlg, LPNMHDR pHdr)
{
	switch(pHdr->code)
	{
	case CLN_TIMECHANGE:
		{
			LPNMCLHDR pHdr2 = (LPNMCLHDR)pHdr;
			TCHAR szText[16];
			_stprintf(szText, _T("%02d:%02d"),
				pHdr2->hour, pHdr2->minute);
			SetDlgItemText(hDlg, IDC_EDIT_CLOCKTIME, szText);
		}
		break;
	}
}