#pragma once

//
// Macros
//

//
// Static
//

#define Static_SetImage(hDlg, ctlId, hBitmap) \
	SendDlgItemMessage(hDlg, ctlId, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(hBitmap))

//
// TextBox
//

//ѡȫı
#define TextBox_SelectAll(hDlg, ctlId) \
	SendDlgItemMessage(hDlg, ctlId, EM_SETSEL, 0, -1)

//ĵַֽ
#define TextBox_SetMaxLength(hDlg, ctlId, nLength) \
	SendDlgItemMessage(hDlg, ctlId, EM_SETLIMITTEXT, (WPARAM)(nLength), 0)

//ıǷֻ
#define TextBox_SetReadOnly(hDlg, ctlId, bReadOnly) \
	SendDlgItemMessage(hDlg, ctlId, EM_SETREADONLY, (WPARAM)(bReadOnly), 0)

//
// Button
//

#define Button_SetBitmap(hwndCtl, hBitmap) \
	SendMessage((hwndCtl), BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)(hBitmap))

#define Button_GetBitmap(hwndCtl) \
	((HBITMAP)SendMessage((hwndCtl), BM_GETIMAGE, (WPARAM)IMAGE_BITMAP, 0))

#define Button_SetIcon(hwndCtl, hBitmap) \
	SendMessage((hwndCtl), BM_SETIMAGE, (WPARAM)IMAGE_ICON, (LPARAM)(hBitmap))

#define Button_GetIcon(hwndCtl) \
	((HBITMAP)SendMessage((hwndCtl), BM_GETIMAGE, (WPARAM)IMAGE_ICON, 0))

//
// Track Bar ( Slider ˿ؼ )
//

#define TrackBar_SetBuddy(hwndCtl, hwndBuddy, bLeftTop) \
	SendMessage((hwndCtl), TBM_SETBUDDY, (WPARAM)(bLeftTop), (LPARAM)(hwndBuddy))

#define TrackBar_GetBuddy(hwndCtl, bLeftTop) \
	((HWND)SendMessage((hwndCtl), TBM_GETBUDDY, (WPARAM)(bLeftTop), 0))

#define TrackBar_SetTicFreq(hwndCtl, freq) \
	SendMessage((hwndCtl), TBM_SETTICFREQ, (WPARAM)(freq), 0)

#define TrackBar_SetPageSize(hwndCtl, pageSize) \
	SendMessage((hwndCtl), TBM_SETPAGESIZE, 0, (LPARAM)(pageSize))

#define TrackBar_SetRange(hwndCtl, rmin, rmax) \
	SendMessage((hwndCtl), TBM_SETRANGE, (WPARAM)FALSE, (LPARAM)MAKELONG((rmin), (rmax)))

#define TrackBar_SetPos(hwndCtl, bRedraw, pos) \
	SendMessage((hwndCtl), TBM_SETPOS, (WPARAM)(bRedraw), (LPARAM)(pos))

#define TrackBar_GetPos(hwndCtl) \
	((int)SendMessage((hwndCtl), TBM_GETPOS, 0, 0))


//
// Progress Bar (  )
//

#define ProgressBar_DeltaPos(hwndCtl, nIncrement) \
	SendMessage((hwndCtl), PBM_DELTAPOS, (WPARAM)(nIncrement), 0)

#define ProgressBar_GetPos(hwndCtl) \
	SendMessage((hwndCtl), PBM_GETPOS, 0, 0)

#define ProgressBar_GetRange(hwndCtl, fLowLimit, pRange) \
	((INT)(SendMessage((hwndCtl), PBM_GETRANGE, (WPARAM)(fLowLimit), (LPARAM)(pRange))))

#define ProgressBar_SetBarColor(hwndCtl, clrBar) \
	SendMessage((hwndCtl), PBM_SETBARCOLOR, 0, (LPARAM)(ctlBar))

#define ProgressBar_SetBkColor(hwndCtl, clrBk) \
	SendMessage((hwndCtl), PBM_SETBKCOLOR, 0, (LPARAM)(ctlBk))

#define ProgressBar_SetMarquee(hwndCtl, bOn, mseconds) \
	SendMessage((hwndCtl), PBM_SETMARQUEE, (WPARAM)(bOn), (LPARAM)(mseconds))

#define ProgressBar_SetPos(hwndCtl, nPos) \
	SendMessage((hwndCtl), PBM_SETPOS, (WPARAM)(nPos), 0)

#define ProgressBar_SetRange(hwndCtl, nMin, nMax) \
	SendMessage((hwndCtl), PBM_SETRANGE, 0, (LPARAM)MAKELPARAM(nMin, nMax))

#define ProgressBar_SetRange32(hwndCtl, iLow, iHigh) \
	SendMessage((hwndCtl), PBM_SETRANGE32, (WPARAM)(int)(iLow), (LPARAM)(int)(iHigh))

#define ProgressBar_SetStep(hwndCtl, nStep) \
	SendMessage((hwndCtl), PBM_SETSTEP, (WPARAM)(int)(nStep), 0)

#define ProgressBar_StepIt(hwndCtl) \
	SendMessage((hwndCtl), PBM_STEPIT, 0, 0)

//
// Helper Functions
//
void GetItemRectInClient(HWND hDlg, int itemId, LPRECT lpRect);

void CenterDialog(HWND hDlg);

//ڶԻϻַ
void DrawStringOnDlg(HDC hdc, LPCTSTR text, int degree, int x, int y);

//ΪԻͼ
void SetIconForDlg(HWND hDlg, LPCTSTR lpszIcon);

void GetAppFolderFileName(LPTSTR buffer, LPCTSTR shortFileName);

//GetLastErrorصĴ룬תΪϢַ
void GetErrorMsg(DWORD errcode, LPTSTR buffer);